/********************************************************************************
**   ()
********************************************************************************/
#pragma once
#ifndef MENUPAR_H
#define MENUPAR_H

#include "ui_menupar.h"
#include<QFileDialog>
#include <QMainWindow>
#include <QSettings>
#include "CSettings.h"

#include "guipar.h"
#include "settings_dialog.h"

using namespace Ui;

class menuPar : public QMainWindow, public menuParClass
{
	Q_OBJECT
private:
	QString saveFileFilter;
	QString curFile;
	bool saveOk;
	QLabel *statusSet;
	Settings_dialog*	set;
	
	void createToolBar();
	void setCurrentFile(const QString &fileName);
	void readSettings();
    void writeSettings();
	void updateStatusBar();
public:
	menuPar(QWidget *parent = 0);
	GUIPar *parser_Gui;
private slots:
	void setWindowChanged(bool);
	bool okToContinue();
	void copy();
	void setDefault_settings_dialog( QAbstractButton * button );
	bool saveLog();
	bool saveLog_as();
	void settings();
	void clear_log();
	void clear_edit();
	void clear_history();
	void about();
protected:
	void closeEvent(QCloseEvent *event);
};
#endif // MENUPAR_H
