/*******************************************************************************
* ,    	,   .*
*******************************************************************************/
#pragma once
#ifndef PARSER_H
#define PARSER_H
#define _USE_MATH_DEFINES

#include <math.h>
#include<vector>
#include <QWidget>
#include "Csettings.h"
#include "Var.h"
#include "functions.h"



using namespace std;



enum types {DELIMITER = 1, VARIABLE, NUMBER,FUNC}; //    
class parser 
{
	char *token2;
	char *exp_ptr;  //   .
	char *token; //   .
	char tok_type;  //   .
	bool if_e;// -     "", ""
	string Function;
	unsigned int countOper;// 
	unsigned int countErr;// 
	double result;//   䳿
	QString error;// 
	QString operation;// 
	bool blocked_input_variables_from_keyboard;
	
	
	void get_token();//   ( ) 
	bool isdelim(char c);//  
	void putback();
	void sumORsub(double &result);
	void mulORdevisionORproc(double  &result);
	void powNum(double &result);
	void unaryMinus_Plus(double &result);
	void functions(double  &result);
	void inBrackets(double &result);
	void returnNum(double &result); //  / 
	double find_var(const char *s);// 
	void set_var(const char *s, double &result);//  
	void ifVar(double &result);

public: 
static	double precision ( const double& value, const double& precision_,const bool &type_precision_is_int_or_pow_1_10_ = true)
{
	if(type_precision_is_int_or_pow_1_10_)
	{
		if(precision_-int(precision_)!=0||precision_<0) return value;
		if(log10(1/precision_)-int(log10(1/precision_))!=0||precision_<0) 	 return value;
		double temp = floor(value / (1/pow(10,double(precision_))) + 0.5) * (1/pow(10,double(precision_)));
		if(temp < pow(double(10),double(-308)))
			return value;
		else return temp;	
		//return  floor(value / (1/pow(10,double(precision_))) + 0.5) * (1/pow(10,double(precision_)))<pow(double(10),double(-308)) ? value : floor(value / (1/pow(10,double(precision_))) + 0.5) * (1/pow(10,double(precision_)));
		
	}
	else 
	{
		if(log10(1/precision_)-int(log10(1/precision_))!=0||precision_<0) 	 return value;
		double temp = floor(value / (precision_) + 0.5) * ((precision_));
		if(temp < pow(double(10),double(-308)))
			return value;
		else return temp;
		//return floor(value / (precision_) + 0.5) * ((precision_)) <) ? value : floor(value / (precision_) + 0.5) * ((precision_));
		
	}

	
}

	
	vector <var> variables;//  .
	
	Csettings options;//`  
	
	
	void SetFunction(const char*);//   
	void SetFunction(const char*, vector <var> variables_);
	parser();
	parser(const char*);
	double start();
	double calculation();
	double calculation(const char*);
	void Clear();//     
	vector <var> vector_variables();
	QString metod_error();// 
	QString metod_operation();// 
	string string_function()
	{

		return Function;
	}

	void set_blocked_input_variables_from_keyboard(bool ok);

//	bool is_variables_in_vector( const vector <var> variables_);
//	bool is_variables_in_vector( const char*);
//	bool add_variables_in_vector(const vector <var> variables_);
	~parser();
};
#endif // PARSER_H
