/********************************************************************************
**   ()   Parser
********************************************************************************/
#pragma once
#ifndef SETTINGS_DIALOG_H
#define SETTINGS_DIALOG_H

#include "ui_settings_dialog.h"
#include "Csettings.h"

using namespace Ui;

class Settings_dialog : public QDialog, public Settings_dialogClass
{
	Q_OBJECT
public:
	Csettings set;
	Settings_dialog(const Csettings &p, QWidget *parent = 0);
	Csettings getSet() {return set;}
	void setWidget_status();
private slots:
	void set_corner();
	void set_precision(int);
	void set_type_number(int);
	void set_formulaInLog();
	void set_resultInLog();
	void set_operationInLog();	
};
#endif // SETTINGS_DIALOG_H