/*******************************************************************************
**    Parser
*******************************************************************************/
#pragma once
#ifndef CSETTINGS_H
#define CSETTINGS_H

struct Csettings
{
	char type_number;// 
	unsigned int precision;//
	bool on_rad;//       
	bool formulaInLog;//    log
	bool resultInLog;//    log
	bool operationInLog;//    log
	Csettings()
	{
		DefaultSettings();// 
	}
	Csettings(char type_precision, unsigned int precision_, bool on_rad_, bool formula_In_Log, bool result_In_Log, bool operation_In_Log)
	{
		type_precision = type_number;
		precision = precision_;
		on_rad = on_rad_;
		formulaInLog = formula_In_Log;
		resultInLog = result_In_Log;
	    operationInLog =  operation_In_Log;
	}
	inline bool operator != (const Csettings &Other) const
	{
		return !(*this == Other);
	}
	inline Csettings &operator = (const Csettings &Other)
	{
		this->formulaInLog = Other.formulaInLog;
		this->on_rad = Other.on_rad;
		this->operationInLog = Other.operationInLog;
		this->precision=Other.precision;	
		this->resultInLog = Other.resultInLog;
		this->type_number = Other.type_number;
		
		return *this; 
	}
	inline bool operator == (const Csettings &Other) const
	{
		return (
		this->formulaInLog == Other.formulaInLog &&
		this->on_rad == Other.on_rad &&
		this->operationInLog == Other.operationInLog &&
		this->precision == Other.precision &&	
		this->resultInLog == Other.resultInLog &&
		this->type_number == Other.type_number);
	}
	void DefaultSettings()
	{
		type_number = 'g';
		precision = 5;
		on_rad = false;
		formulaInLog = true;
		resultInLog = true;
	    operationInLog = false;
	}
};
#endif // CSETTINGS_H