#include"parser.h"

parser::parser()
{
        token = token2 = NULL;

        if_e = false;
        blocked_input_variables_from_keyboard=0;
		result=0;
		options.type_number=15;
};
parser::parser(const char *lpszFunction)
{       
        token = token2 = NULL;

        if_e = false;
			result=0;
        SetFunction(lpszFunction);
		options.type_number=15;
}
void parser::SetFunction(const char* lpszCommand)
{
        countErr = 0; 
        error.clear();
        countOper = 0;
        operation.clear(); 
        
        Function = lpszCommand; 

        if(token2 != NULL) delete [] token2;
        token = token2 = new(std::nothrow) char[Function.size()+1];
        
        exp_ptr = &Function[0];
        operation = QWidget::tr("Operations:\n");
}
void parser::SetFunction(const char* lpszCommand, vector <var> variables_)
{
        countErr=0;
        countOper=0;
        
        Function=lpszCommand;   

        if(token2 != NULL) delete [] token2;
        token = token2 = new(std::nothrow) char[Function.size()+1];
                
        variables = variables_;
        

        exp_ptr =& Function[0];
        operation=QWidget::tr("Operations:\n");
}

void parser::set_blocked_input_variables_from_keyboard(bool ok)
{
	blocked_input_variables_from_keyboard=ok;
}

void parser::Clear()
{       
        exp_ptr = NULL;
        variables.clear();
        error.clear();
        operation.clear();
        Function.clear();
        result = 0;
}
parser::~parser()
{
	
	
	delete []token2;
	
}
//  , 
double parser::start() 
{
	get_token(); 
	if(!*token) 
	{
		countErr++;
		error += QString::number(countErr) + ": " + QWidget::tr("Empty expression;\n"); 
		 //  .
	}
	ifVar(result) ; 
	
	if(*token)
	{		
		countErr++;
		error += QString::number(countErr) + ": " + QWidget::tr("Incorrect expression;\n"); 
	}//       
	if(result >pow(double(10), double(308))) 
	{
		countErr++;
		error += QString::number(countErr) + ": " + QWidget::tr("A result beyond acceptable definition for 32bit OS;\n");
	}
	if(!error.isEmpty())
	{
		result = 0;
	}
//	else set_var("ans", result);
	return result;
}
void parser::ifVar( double &result)
{
	char ttok_type;
	char temp_token[80];
	string h;

	if(tok_type == VARIABLE)   
	{
		h = token;
//   , 
		strcpy(temp_token, token);
		ttok_type = tok_type;
 
	
		get_token();
		
		
		if(*token != '=') 
		{
			
			putback(); //   . 
			
			// ³   -//    
			strcpy(token, temp_token);
			tok_type = ttok_type;
				
		}
		else 
		{
			//     
		
			get_token(); 
			
			sumORsub(result);

			if(blocked_input_variables_from_keyboard)
			{
			
				countErr++;
				error += QString::number(countErr) + ": " + QWidget::tr("Input your variables blocked\n");

				return;
			}

			if(error.isEmpty())
				set_var((const char*)h.c_str(), result);
			
			return;
		}
	}
	sumORsub(result);
}
//    
void parser::sumORsub(double &result)
{
	register char op; 
	double temp;
	mulORdevisionORproc(result);
	
	while((op = *token) == '+' || op == '-') 
	{ 
		get_token(); 
		mulORdevisionORproc(temp);
		switch(op)
		{ 
			case '-':
				countOper++;
				operation += QString::number(countOper) + ": " + QString::number(result,options.type_number,options.precision) + " - " + QString::number(temp,options.type_number) + " = " + QString::number(result - temp,options.type_number,options.precision) + "\n";
				
				result = result - temp; 
				result = precision ( result, options.precision);
				
				break; 
			case '+':
				countOper++;
				operation += QString::number(countOper) + ": " + QString::number(result,options.type_number,options.precision) + " + " + QString::number(temp,options.type_number,options.precision) + " = " + QString::number(result + temp,options.type_number,options.precision) + "\n";
				
				result = result + temp; 
				result = precision ( result, options.precision);
				
				break;
		}
	}
}
//  /  / 
void parser::mulORdevisionORproc(double &result)
{
	register char op;
	double temp;
	unaryMinus_Plus(result); 
	while((op = *token) == '*' || op == '/' || op == '%') 
	{ 
		get_token(); 
		powNum(temp); 
		switch(op)
		{
			case '*':	
				countOper++;
				operation += QString::number(countOper) + ": " + QString::number(result,options.type_number,options.precision) + " * " + QString::number(temp,options.type_number,options.precision) + " = " + QString::number(result * temp,options.type_number,options.precision) + "\n";
				
				result = result * temp;
				result = precision ( result, options.precision);
				break; 
			case '/': 
				if(temp == 0) 
				{
					countErr++;
					error += QString::number(countErr) + ": " + QWidget::tr("Division by 0;\n");
					result = 0;
					break;
				}
				else
				{
					countOper++;
					operation += QString::number(countOper) + ": " + QString::number(result,options.type_number,options.precision) + " / " + QString::number(temp,options.type_number,options.precision) + " = " + QString::number(result / temp,options.type_number,options.precision) + "\n";
					
					result = result / temp;
					result = precision ( result, options.precision); 
					break;
				}
			case '%':
				countOper++;
				operation+=QString::number(countOper) + ": " + QString::number(result,options.type_number,options.precision) + " % " + QString::number(temp,options.type_number,options.precision) + " = " + QString::number(result / 100 * temp,options.type_number,options.precision)+"\n";
				
				result = result / 100 * temp; 
				result = precision ( result, options.precision);
				break;
		}
	}
}
// ϳ  
void parser::powNum(double &result)
{
	double temp=0, ex = 0;
	
	//unaryMinus_Plus(result);
	functions(result);
	
	while(*token == '^') 
	{
		get_token(); 
		
		//unaryMinus_Plus(temp); 
		functions(temp);
		ex = temp; 
		
		countOper++;
		operation += QString::number(countOper) + ": " + QString::number(result,options.type_number,options.precision) + " ^ " + QString::number(ex,options.type_number,options.precision) + " = " + QString::number(precision (pow(result, ex), options.precision)) + "\n";
		if (result == 0 && ex <= 0) 
		{
			countErr++;
			error += QString::number(countErr) + ": " + QWidget::tr("Expression 0^;\n");
			result = 0;
			return;
		}
		if(abs((int)ex / 2) == 0&&result < 0 && abs(ex / 2 - (int)ex / 2) != 0.5) 
		{
			countErr++;
			error += QString::number(countErr) + ": " + QWidget::tr("Sqrt(expression) or expression^0.5 - expression <0;\n");
			result = 0;
			return;
		}
		else 
		{
			
			result = pow(result, ex);
			result = precision ( result, options.precision);
		}
	}
}
//    + / -. 
void parser::unaryMinus_Plus( double &result) 
{
	register char  op;
	op = 0;
	if((tok_type == DELIMITER) && *token=='+' || *token == '-')
	{
		op = *token;
		get_token();
	}
	powNum(result);
	
	if(op=='-')	{precision ( result, 2);result = -result;}
	if (op == '-' || op == '+') 
	{
		countOper++;
		operation += QString::number(countOper) + ": " + QWidget::tr("unary operation: ") + QString::number(result) + "\n";
	}
}
//  ,       
void parser::inBrackets(double &result)
{	
	if((*token == '(')) 
	{
		get_token() ; 
		sumORsub(result); 
	
		if(*token != ')' && !isalpha(*token) && !ispunct(*token))
		{
			countErr++;
			error += QString::number(countErr) + ": " + QWidget::tr("Not );\n");
		}
		countOper++;
		operation += QString::number(countOper) + ": " + QWidget::tr("expression in brackets: ") + QString::number(result) + "\n";
		
		if(!isalpha(*token)) get_token(); 
	} 
	else returnNum(result);
}
// 
void parser::functions(double &result)
{
	if(tok_type == FUNC)
	{
		if(strcmp(token,func[0]) == 0)
		{
			get_token();
			inBrackets(result);

			countOper++;
			operation += QString::number(countOper) + ": " + "pi(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(result * M_PI,options.type_number,options.precision) + "\n";
			
			result = M_PI * result;
			result = precision ( result, options.precision);
			return;
		}
		else if (strcmp(token,func[1]) == 0)
		{			
			get_token();
			inBrackets(result);;

			countOper++;
			operation += QString::number(countOper) + ": " + "rad("+QString::number(result,options.type_number,options.precision) + ") = " + QString::number((result) * M_PI / 180,options.type_number,options.precision) + "\n";
			
			result = (result) * M_PI / 180;
			result = precision ( result, options.precision);
			return;
		}
		else if (strcmp(token,func[2]) == 0)
		{			
			get_token();
			inBrackets(result);

			countOper++;
			operation += QString::number(countOper) + ": " + "deg(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number((result) * 180 / M_PI,options.type_number,options.precision) + "\n";
			
			result = (result) * 180 / M_PI;
			result = precision ( result, options.precision);
			return;
		}
		else if(strcmp(token,func[3]) == 0)	
		{	
			get_token() ; 
			inBrackets(result);
			
			double answer = 0;

			countOper++;
			operation += QString::number(countOper) + ": ";

			if(options.on_rad == true)
			{
				operation += QWidget::tr("rad ");
			}
			else
			{
				operation += QWidget::tr("deg ");
			}
			if(result / M_PI - int(result/M_PI) == 0 && options.on_rad == true || result / 180 - int(result / 180) == 0 && options.on_rad == false) 
			{
				answer = 0;
			}
			else if(options.on_rad == false) 
			{
				answer = sin(result * M_PI / 180);
			}
			else if(options.on_rad == true)
			{
				answer = sin(result);
			}
			
			operation += "sin(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(answer,options.type_number,options.precision) + "\n";
			result = answer;
			result = precision ( result, options.precision);
			return;
		}
		else if(strcmp(token,func[4]) == 0)
		{
			get_token() ; 
			inBrackets(result);

			countOper++;
			operation += QString::number(countOper) + ": ";

			double answer = 0;

			if(options.on_rad == true)
			{
				operation += QWidget::tr("rad ");
			}
			else
			{
				operation += QWidget::tr("deg ");
			}
			if(fabs(result / M_PI - int(result / M_PI)) == 0.5 && options.on_rad == true || fabs(result / 180 - int(result / 180)) && options.on_rad == false) 
			{
				answer = 0;
			}
			else if(options.on_rad == false)
			{
				answer = cos(result * M_PI / 180);
			}
			else if(options.on_rad == true)
			{
				answer = cos(result);
			}

			operation += "cos(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(answer,options.type_number,options.precision) + "\n";
			result = answer;
			result = precision ( result, options.precision);

			return;
		}
		else if(strcmp(token,func[5]) == 0)//
		{
			get_token();
			inBrackets(result);
			
			double answer = 0;
			double fraction = 0;

			if(options.on_rad == true)
			{
				fraction = result / M_PI - int(result / M_PI);
			}
			else
			{
				fraction = result / 180 - int(result / 180);
				
			}
			if (fabs(fraction) == 0.5) 
			{
				countErr++;
				error += QString::number(countErr) + ": " + QWidget::tr("Can't calculate tan - incorrect angle;\n");
				result = 0; return;
			}
			
			countOper++;
			operation += QString::number(countOper) + ": ";

			if(options.on_rad == true)
			{
				operation += QWidget::tr("rad ");
				answer = tan(result);
			}
			else if(options.on_rad == false)
			{
				operation += QWidget::tr("deg ");
				answer = tan(result * M_PI / 180);
				
			}
			if(fraction == 0) 
			{
				answer = 0;
			}
			operation += "tan(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(answer,options.type_number,options.precision) + "\n";
			result = answer;
			result = precision ( result, options.precision);
			return;
		}
		else if (strcmp(token,func[6]) == 0)
		{
			get_token();
			inBrackets(result);
			
			double answer = 0;
			double fraction = 0;

			if(options.on_rad == true)
			{
				fraction = result / M_PI - int(result / M_PI);
			}
			else
			{
				fraction = result / 180 - int(result / 180);
			}
		
			if (fraction == 0) 
			{
				countErr++;
				error += QString::number(countErr) + ": " + QWidget::tr("Can't calculate cot - incorrect angle;\n");
				result = 0; return ;
			}
			
			countOper++;
			operation += QString::number(countOper) + ": ";

			if(options.on_rad == true)
			{
				operation += QWidget::tr("rad ");
				answer = 1 / tan(result);
			}
							
			else if(options.on_rad == false)
			{
				operation += QWidget::tr("deg ");
				answer = 1 / tan(result * M_PI / 180);
			}
			if (fabs(fraction) == 0.5) 
			{
				answer = 0;
			}
		
			operation += "cot(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(answer,options.type_number,options.precision) + "\n";
			result = answer;
			result = precision ( result, options.precision);
			return;
		}
		else if (strcmp(token,func[7]) == 0)
		{
			get_token();
			inBrackets(result);
			
			if(result < -1 || result > 1)
			{ 
				countErr++;
				error += QString::number(countErr) + ": " + QWidget::tr("Argument of asin is out of ranges;\n");
			
				result=0; return;
			}
			double answer = 0;
			countOper++;
			operation += QString::number(countOper) + ": ";
			if(options.on_rad == false)
			{
				operation += QWidget::tr("deg ");
				answer = asin(result) * 180 / M_PI;
			}
			else 
			{
				operation += QWidget::tr("rad ");
				answer = asin(result);
			}

			operation += "asin(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(answer,options.type_number,options.precision) + "\n";
			result = answer;
			result = precision ( result, options.precision);
			return;
		}
		else if (strcmp(token,func[8]) == 0)
		{
			get_token();
			inBrackets(result);

			if(result < -1 || result > 1) 
			{
				countErr++;
				error += QString::number(countErr) + ": " + QWidget::tr("Argument of acos is out of ranges;\n");
				result = 0; return;
			}
			double answer = 0;
			countOper++;
			operation += QString::number(countOper) + ": ";
			if(options.on_rad == false)
			{
				operation += QWidget::tr("deg ");
				answer = acos(result) * 180 / M_PI;
			}
			else 
			{
				operation += QWidget::tr("rad ");
				answer = acos(result);
			}

			operation += "acos(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(answer,options.type_number,options.precision) + "\n";
			result = answer;
			result = precision ( result, options.precision);
			return;
		}
		else if (strcmp(token,func[9]) == 0)
		{
			get_token();
			inBrackets(result);
			
			double answer = 0;
			countOper++;
			operation += QString::number(countOper) + ": ";

			if(options.on_rad == false)
			{
				operation += QWidget::tr("deg ");
				answer = atan(result) * 180 / M_PI;
			}
			else 
			{
				operation += QWidget::tr("rad ");
				answer = atan(result);
			}

			operation += "atan(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(answer,options.type_number,options.precision) + "\n";
			result = answer;
			result = precision ( result, options.precision);
			return;
		}
		else if (strcmp(token,func[10]) == 0)
		{			
			get_token();
			inBrackets(result);;

			double answer = 0;
			countOper++;
			operation += QString::number(countOper) + ": ";

			if(options.on_rad == false)
			{
				operation += QWidget::tr("deg ");
				answer = -atan(result) * 180 / M_PI + 2 * atan(double(1)) * 180 / M_PI;
			}
			else 
			{
				operation += QWidget::tr("rad ");
				answer = -atan(result) + 2 * atan(double(1));
			}

			operation += "acot(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(answer,options.type_number,options.precision) + "\n";
			result = answer;
			result = precision ( result, options.precision);
			return;
		}
		else if (strcmp(token,func[11]) == 0)
		{			
			get_token();
			inBrackets(result);

			countOper++;
			operation += QString::number(countOper) + ": int(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(int(result)) + "\n";
		
			result = int(result);
			result = precision ( result, options.precision);
			return;
		}
		else if (strcmp(token,func[12]) == 0)
		{			
			get_token();
			inBrackets(result);;

			countOper++;
			operation += QString::number(countOper) + ": frac(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(result - int(result),options.type_number,options.precision) + "\n";
		
			result = result - int(result);
			result = precision ( result, options.precision);
			return;
		}
		else if(strcmp(token,func[13]) == 0)
		{
			get_token();
			inBrackets(result);

			countOper++;
			operation += QString::number(countOper) + ": abs(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(fabs(result),options.type_number,options.precision) + "\n";
			
			result = fabs(result);
			result = precision ( result, options.precision);
			return;
		}
		else if (strcmp(token,func[15]) == 0)
		{
			get_token();
			inBrackets(result);
			
			if(result <= 0) 
			{
				countErr++;
				error += QString::number(countErr) + ": " + QWidget::tr("Argument of log is <=0;\n");
			
				result = 0; return;
			}
			else 
			{
				countOper++;
				operation += QString::number(countOper) + ": log(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(log(result),options.type_number,options.precision) + "\n";

				result = log(result);
				result = precision ( result, options.precision);
			}
			return;
		}
		else if (strcmp(token,func[16]) == 0)
		{
			get_token();
			inBrackets(result);
			
			if(result <= 0) 
			{
				countErr++;
				error += QString::number(countErr) + ": " + QWidget::tr("Argument of log2 is <=0;\n");
			
				result = 0; return;
			} 
			else 
			{
				countOper++;
				operation += QString::number(countOper) + ": log2(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(log(result) / log((double)2),options.type_number,options.precision) + "\n";

				result = log(result) / log((double)2);
				result = precision ( result, options.precision);
			}
			return;
		}
		else if (strcmp(token,func[17]) == 0)
		{
			get_token();
			inBrackets(result);

			if(result <= 0) 
			{
				countErr++;
				error += QString::number(countErr) + ": " + QWidget::tr("Argument of log10 is <=0;\n");
				result = 0; return;
			}
			else 
			{
				countOper++;
				operation += QString::number(countOper) + ": log10(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(log10(result),options.type_number,options.precision) + "\n";
			
				result = log10(result);
				result = precision ( result, options.precision);
			}
			return;
		}
		else if (strcmp(token,func[18]) == 0) 
		{
			get_token();
			inBrackets(result);

			countOper++;
			operation += QString::number(countOper) + ": exp(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(exp(result),options.type_number,options.precision) + "\n";

			result = exp(result);
			result = precision ( result, options.precision);
			return;
		}		
		else if(strcmp(token,func[19]) == 0)
		{
			get_token();
			inBrackets(result);

			if(result < 0) 
			{
				countErr++;
				error += QString::number(countErr) + ": " + QWidget::tr("Expression <0;\n");
				result = 0; return;
			}
			else
			{
				countOper++;
				operation += QString::number(countOper) + ": sqrt(" + QString::number(result,options.type_number,options.precision) + ") = " + QString::number(sqrt(result),options.type_number,options.precision) + "\n";
				
				result = sqrt(result);
				result = precision ( result, options.precision);
			}
			return;
		}
		else if(strcmp(token,func[20]) == 0)
		{
			get_token();
			inBrackets(result);

			double res = result;

			if(res - int(res)!=0)
			{
				countErr++;
				error += QString::number(countErr) + ": " + QWidget::tr("Factorial from fraction number;\n");
				return;
			}
			if(res < 0)
			{
				countErr++;
				error += QString::number(countErr) + ": " + QWidget::tr("Factorial from number<0;\n");
				return;
			}
			if(result == 0)
				result =1;
			else 
			{
				double temp = 1;
				for(int i = 1; i < result+1; i++)
				{
					temp *= i;
				}
				result = temp; 
			}
			countOper++;
			result = precision ( result, options.precision);
			operation += QString::number(countOper) + ": fac(" + QString::number(res,options.type_number,options.precision) + ") = " + QString::number(result,options.type_number,options.precision) + "\n";
		}
		else if(tok_type == FUNC ) 
		{
			countErr++;
			error += QString::number(countErr) + ": " + QWidget::tr("Incorrect function;\n");
			result = 0; 
			return;
		}
	}
	else inBrackets(result);
}
//     
void parser::returnNum( double &result)
{
	switch(tok_type)	
	{
		case VARIABLE: 
			result = find_var((const char*)token);
			result = precision ( result, options.precision);
			countOper++;
			operation += QString::number(countOper) + ": " + QWidget::tr("return variable: ") + QString(token) + " = " + QString::number(result,options.type_number,options.precision) + "\n";
			get_token();
			return; 
		case NUMBER:	
			char *endptr;
			result = strtod(token,&endptr);
			result = precision ( result, options.precision);
			if((*endptr) != '\0') 
			{
				countErr++;
				error += QString::number(countErr) + ": " + QWidget::tr("Can`t scan this number;\n"); return;
			}
			/*countOper++;
			operation += QString::number(countOper) + ": " + QWidget::tr("return number: ") + QString::number(result) + "\n";*/
			get_token();
			return; 
		default: 
			{
				countErr++;
				error += QString::number(countErr) + ": " + QWidget::tr("Syntax error;\n");
			}
	}
}
//  
void parser::get_token()
{
char *temp;
	temp=token;
	*temp='\0';
	tok_type = 0;
	
	
	
	if(!*exp_ptr) return; // ʳ 

	while(isspace(*exp_ptr)) ++exp_ptr; //   
	if(strchr("+-*//*%=()^", *exp_ptr) || (ispunct(*exp_ptr)&&*exp_ptr != '.'))
	{
		tok_type = DELIMITER;
	//    .
		*temp++ = *exp_ptr++;
	} 
	else if(isdigit(*exp_ptr) || *exp_ptr == '.') 
	{
		bool if_e = false;
		
			while(!isdelim(*exp_ptr)) 
			{
				*temp++ = *exp_ptr++;
			}
			
		tok_type = NUMBER;
	}
	else if(isalnum(*exp_ptr))//  .  -   
	{
		while(isalnum(*exp_ptr)||*exp_ptr=='_')*temp++ =* exp_ptr++;
		if(*exp_ptr == '(') tok_type = FUNC;
		else tok_type = VARIABLE;
	}
*temp='\0';


}
//      - true. 
bool parser::isdelim(char c) 
{	if(c == 'e'||c == 'E') 
	{
		if_e = true;
		return false;
	}
	if(if_e == true && (c == '-' || c == '+')) 
	{
		if_e = false;
		return false;
	}
	if(!isdigit(c) && c != '.') 
	{
		if_e = false;
		return true;
	}	
	return 0;
}
//    
double parser::find_var(const char *s) 
{
	string temp = s;

	//vector<var>::iterator current = variables.begin();

	for (int j = variables.size() - 1; j > -1; j--)
	{
		//++current;

		if(temp == variables[j].x)
		{
			return variables[j].num;
		}
	}
		countErr++;
		error += QString::number(countErr) + ": " + QWidget::tr("Variable ") + QString(temp.c_str()) + QWidget::tr(" not found;\n");
		return 0;
}
//   
void parser:: set_var(const char *s,double &result)
{	
	string temp = s;
	
	bool okVar = false;
	
	for(int y = 0; y < variables.size(); y++)
	{
		if(variables[y].x == temp) 
		{
			result = precision ( result, options.precision);
			variables[y].num = result;
			okVar = true;
		}
	}
	if(okVar == false)
	{
		result = precision ( result, options.precision);
		variables.push_back(var(temp, result));
	}
}
void parser::putback()
{
	char * t;
	t = token;
	for(; *t; t++) exp_ptr--;
}
double parser::calculation()
{
	return result;
}
vector <var> parser::vector_variables()
{
	return variables;
}
QString parser::metod_error()
{
	return error;
}
	;// 
QString parser::metod_operation()
{
	return operation;
}
	;// 

/*	bool parser::is_variables_in_vector( const vector <var> variables_)
{
	return 0;
}

/*

bool parser::is_variables_in_vector( const char* s)
{
			string temp = s;



	for (int j = variables.size() - 1; j > -1; j--)
	{
		

		if(temp == variables[j].x)
		{
			return true;
		}
	}
	return false;
}
bool parser::add_variables_in_vector(const vector <var> variables_)
{
	bool ok=false;
	for(int i=0; i<variables_.size();i++)
	{
		double num = variables_[i].num;
		if(is_variables_in_vector(variables_[i].x.c_str()));
			ok=true;

			set_var(variables_[i].x.c_str(),num);
			
			
		
	}
		return ok;
}

*/
